<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" />
  <title>Пн 09 мая 2022 00:21:49 EET Markdown/AsciiMath to HTML (by marked)</title>
  <link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/github-markdown-css/3.0.1/github-markdown.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.4/latest.js?config=AM_CHTML"></script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  asciimath2jax: {
    delimiters: [['$','$']]
  }
});
  </script>
  <script src="https://cdn.jsdelivr.net/npm/marked/marked.min.js"></script>
</head>
<body class="markdown-body">
  <div id="display"></div>
  <script>
    content =
"# Practical course Networking Lab \n\n## Lab2 - Worked on by Aleksei Makarov and Egi Brako\n\n## Here is an important notice. For exercises from 1 to 9 we were supposed to change the IP addresses of PC\'s from default to the special, mentioned in the network setup. We unfortunately did not do this, but it did not affect the sense and idea of the exercises. It was important only for exercise 7, but by then we had noticed it and changed it respectively for that one.\n\n### Exercise 1\n\nSee the files `ex1, ex1_2`, the second file contains only *ICMP*-messages (the same for removing all non-*ICMP*)\n\n### Exercise 2\n\nSee the file `ex2.out`.\n\n### Exercise 3\n\nSee the file `ex3.out`.\n\n### Exercise 4\n\n1. See the file `ex4_1.out`.\n\n2. See the file `ex4_2.out`.\n\n3. See the file `ex4_3.out`.\n\n### Exercise 5\n\nSee the file `exs5.out`.\n\n1. The typical MAC address of an ARP request packet should be the Ethernet broadcast address: *ff:ff:ff:ff:ff:ff*.\n\n2. The type field in received Ethernet headers is `Ethernet II`.\n\n3. The process which ARP uses to acquire a MAC address for a given IP address works so:\n\n\nWe want to send an `ICMP` Echo request from PC1 to PC2. We do this by usual `ping` command.\n\nIf the MAC-address in the cached ARP table on PC1 is not outdated yet, then PC1 just sends the Ethernet frame containing the IP packet. Otherwise PC1 should send a broadcast ARP request message (dest. MAC address will be Ethernet broadcast address).\n\nThen PC2 responds with an ARP response message containing its MAC address.\n\nOn PC1 the cached ARP table will be updated, then PC1 can send the Ethernet frame with IP packet.\n\n\n\n\n### Exercise 6\n\nSee the file `ex6`.\n\n\n### Exercise 7\n\nSee the file `ex7.out`.\n\n1. The interval between each ARP request is nearly 1 second. Since PC1 is not receiving any ARP response message, it continues to send ARP requests to a Ethernet broadcast address.\n\n2. ARP cannot be encapsulated, because it\'s exactly the job of ARP itself: encapsluta IP datagrams into Ethernet frames, they are just working on different network layers.\n\n### Exercise 8\n\n1. See the files `ex8_1, ex8_2`. \n2. The mtu for a loopback interface is 65535 bytes, for *eth0* - 1500 bytes.\n\n### Exercise 9\n\nSee the files `ex9_1` and `ex9_2`.\n\n### Exercise 10\n\nSee the file `ex10_1` for output.\n\nTo explain the output of the command `ip addr` let\'s take a look at the following line:\n\n<br>\n3: eth0: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc mq state UP group default qlen 1000\n    link/ether 00:e0:4c:00:0a:10 brd ff:ff:ff:ff:ff:ff\n    inet 10.10.10.11/24 brd 10.10.10.255 scope global eth0\n    \n*eth0* - name of the interface\n*BROADCAST, MULTICAST, UP, LOWER_UP* - interface supports broadcast and multicast, is turned on (UP) and has connected a wire into it (LOWER_UP)\n*mtu* - maximum transmission unit - 1500 bytes\n*qdisc* - is the queueing discipline. *mq* is a dummy scheduler for this.\n*group default* - the group of interfaces give a single interface to user by combining the capabilities\n*qlen* - length of queue, if there are 1000 packets in queue, the next one will be dropped\n\nThe next few lines describe the MAC address (and a broadcast address) and IP address,\n<br>\n\n### Exercise 11\n\nSee the file `ex11_1` for output.\n\n1. The hostname is PC4.\n\n2. There will be no error message, because the last device, which sent an ARP response simply overwrote the corresponding entry of the ARP table on PC1.\n\n### Exercise 12\n\nThe files `ex12_1to2, ex12_1to3, ex12_1to4, ex12_2to1` contain the results of `ping` commands. There is no output file since we\'ve got the mistake that host is unreachable. The file `ex12_1_all_wireshark.out` is the capture of all packets from/to PC1.\n\n### Exercise 13\n\n1. This method is impractical for networks with a lurge number of hosts, because we should save all mappings for each host. Therefore if just one hosts changes his name, we should do it for every other host too.\n\n2. The result will be just the first ip address, which will be found from beginning of the file with the host name we are looking for.\n\n### Exercise 14\n\nSee the file `ex14.out` for output.\n\n1. The ftp client uses a random high-numbered port for the source, in our case the Src port was 53565. The ftp server uses destination (Dst) port 21.\n\n2. The login name and pass could be found in a file in following segments: Request: USER ubuntu, Request: PASS lab.\n\n### Exercise 15\n\nSee the file `ex15.out` for output. Thre are multiple lines which contain separate characters `u, b, u, n, t, u` and `l, a, b`. The transmission of login and password begins at the line 187: `    Data: PC2 login: `. While the behaviour may be a bit different from the two protocols, as much as it concerns the user they have the exact same security flaws.\n\n### Exercise 16\n\nSee the file `ex16.out` for output. The 3 for each character are defined as follows: The first is just source-destination packet, which contains the data. The second is ACK from receiver to source and the third is ACK on ACK, sent from source host to receiver.\n\n\n";async function displayer(){ // MathJax is not usable right after import, so we just wait and check until it is
    // markdown and asciimath do not naturally cooperate - we have to extract the asciimath parts and insert them later
	// we have to differentiate though: if the asciimath parts were in code areas (i.e. pre-tags), then we do not want to convert them
	//
	// we note that asciimath and pre-tags can not be interleaved in any sensible way, so we ignore that case
	var mathCounter = 0;
	var mathContents = [];
	while(((content.match(/\$/g) || []).length >= 2)){ // while there is still possible AsciiMath
		var start = content.indexOf("$");
		var end = content.indexOf("$", start + 1);
		mathContents.push(content.substring(start, end + 1));
		content = content.substring(0, start) + "<span id = 'ASCIIMATHREINSERTIONPLACEHOLDER" + mathCounter + "'></span>" + content.substring(end + 1); // it would be nicer to do without this, but what about sorting out hBsigns inside backtick-maths, or the other way around?
		mathCounter++;
	}

	while(typeof(MathJax) == "undefined"){ // we need MathJax in the next step, and may have to wait until it is initialized (does not happen on immediately import (even though it is not async))
		await new Promise(resolve => setTimeout(resolve, 100));
	}
	document.getElementById("display").innerHTML = marked.parse(content);
	for(var mathNumber = 0; mathNumber < mathCounter; mathNumber++){ // here we go through all parent elements of any contained tag and check if they are <pre>-elements if one is, then this is code ()
		var edEl = document.getElementById('ASCIIMATHREINSERTIONPLACEHOLDER' + mathNumber);
		if(edEl == null){ // the tag has fallen into a code area, turning it into plain text
		    document.body.outerHTML = document.body.outerHTML.replace("&lt;span id = 'ASCIIMATHREINSERTIONPLACEHOLDER" + mathNumber + "'&gt;&lt;/span&gt;", mathContents[mathNumber])
		}
		else{
			edEl.innerHTML = mathContents[mathNumber];
			MathJax.Hub.Typeset(edEl);
		}
	}
  };

  displayer();
  </script>
</body>
</html>

</body>
</html>
